<?php

Class Operaciones {

    public $username = 'adm1n1st_vacorp';
    public $password = '#TrV1U?)9~!z';
    public $dbname = 'adm1n1st_vacorp_production_server';
    /*public $username = 'root';
    public $password = 'mysql';
    public $dbname = 'va_corp_server';*/
    public $mysqli;
	
    function conectar() {

        $this->mysqli = new mysqli($this->host, $this->username, $this->password, $this->dbname);
        if ($this->mysqli->connect_errno) {
                echo "Fallo al conectar a MySQL: (" . $this->mysqli->connect_errno . ") " . $this->mysqli->connect_error;
        }
        $this->mysqli->set_charset("utf8");
    }
	
    ///$country es PTY o DOM
    public function login($username, $password, $version) {

        $passmd5 = md5($password);
        $versionActual = 7;

        if($version != $versionActual) {
            $fila = array("warning" => "Debe actualizar a la nueva version para poder ingresar al sistema.");
            //$fila = array("warning" => "Actualmente no es posible acceder al sistema.");
        } else {
            $this->conectar();
            $sql = "SELECT CONCAT(s.nombres,' ',s.apellidos) as nombre, u.username, u.id, s.pais_id, s.id as shopper_id, r.nombre as perfil "
                . "FROM usuario u "
                . "INNER JOIN role r ON r.id = u.role_id "
                . "INNER JOIN shopper s ON s.usuario_id = u.id "
                . "WHERE u.username = '$username' "
                . "AND u.password = '$passmd5' "
                . "AND r.activo = 1 AND u.activo = 1";
        
            $resultado = $this->mysqli->query($sql) or die ('No se ha podido realizar la operacion : '.$sql);
            $cantidad = mysqli_num_rows($resultado);

            if($cantidad == 1) {
                $fila = $resultado->fetch_assoc();

                if($fila['perfil'] != 'NETWORKER') {
                    $sql = "SELECT e.fecha_cierre, p.ciclo_id "
                            . "FROM embarque e "
                            . "INNER JOIN paisembarque pe ON pe.embarque_id = e.id "
                            . "INNER JOIN pais p ON p.id = pe.pais_id "
                            . "WHERE e.activo = 1 AND pe.pais_id = ".$fila['pais_id'];
                            //. "WHERE e.id = 64 AND pe.pais_id = ".$fila['pais_id'];
                    
                    $resultado = $this->mysqli->query($sql) or die ('No se ha podido realizar la operacion : '.$sql);
                    $emb = $resultado->fetch_assoc();           
                    $fila['fechaModificacion'] = $emb['fecha_cierre'];
                    $fila['cicloId'] = $emb['ciclo_id'];
                    $fila['paisId'] = $fila['pais_id'];
                }

            } else {
                $fila = array("warning" => "Usuario no encontrado");
            }           
            $this->mysqli->close();
        }

        return $fila;
    }

    public function registrar($api, $cedula) {

        $this->conectar();
        $sql = "UPDATE usuario SET apicgm = '$api' WHERE username = '$cedula'";
        $resultado = $this->mysqli->query($sql) or die ('No se ha podido realizar la operacion : '.$sql);
    }
	
    public function getNetworkersCicloActivo($cedulaNetworker) {

        $this->conectar();
        
        //Busco la informacin del Networker
        $sql = "SELECT id, gerente, pais_id "
                . "FROM networker "
                . "WHERE cedula = '$cedulaNetworker'";
        $resultado = $this->mysqli->query($sql) or die ('No se ha podido realizar la operacion : '.$sql);
        $cantidad = mysqli_num_rows($resultado);
        $networker = $resultado->fetch_assoc();
        
        //Busco la lista de shoppers
        if($networker['gerente'] == 0) {
            $sql = "SELECT s.nombres, s.apellidos, s.cedula, s.id
                    FROM shopper s
                    INNER JOIN networker n ON s.networker_id = n.id
                    INNER JOIN usuario u ON u.id = s.usuario_id
                    WHERE n.id = " . $networker['id'] . " AND u.activo = 1
                    ORDER BY 1 ASC";	
        } else {
            $sql = "SELECT s.nombres, s.apellidos, s.cedula, s.id
                    FROM shopper s
                    INNER JOIN networker n ON s.gerentezona_id = n.id
                    INNER JOIN usuario u ON u.id = s.usuario_id
                    WHERE n.id = " . $networker['id'] . " AND u.activo = 1
                    ORDER BY 1 ASC";
        } 
        $resultado = $this->mysqli->query($sql) or die ('No se ha podido realizar la operacion : '.$sql);
        $cantidad = mysqli_num_rows($resultado);		
        if($cantidad > 0) {
            while($data = $resultado->fetch_assoc())
                    $fila[] = json_encode($data);
        } else {
                $fila = array("warning" => "Sin Personal Shopper asociados");
        }	
        $return['shoppers'] = $fila;

        //Busco la fecha de cierre del ciclo actual
        $sql = "SELECT e.fecha_cierre as fechaCierre, p.ciclo_id as cicloId, p.id as paisId, CONCAT(ca.numero,' ciclo ',c.nombre) as descripcion "
                . "FROM embarque e "
                . "INNER JOIN paisembarque pe ON pe.embarque_id = e.id "
                . "INNER JOIN pais p ON p.id = pe.pais_id "
                . "INNER JOIN ciclo c ON c.id = p.ciclo_id "
                . "INNER JOIN campana ca ON ca.id = c.campana_id "
                . "WHERE e.activo = 1 AND pe.pais_id = ".$networker['pais_id'];        
        $resultado = $this->mysqli->query($sql) or die ('No se ha podido realizar la operacion : '.$sql);
        $cantidad = mysqli_num_rows($resultado);		
        if($cantidad > 0) {
            while($data = $resultado->fetch_assoc())
                    $ciclo[] = json_encode($data);
        } else {
                $ciclo = array("warning" => "No hay ciclos activos");
        }
        $return['ciclo'] = $ciclo;

        $this->mysqli->close();
        return $return;				
    }
	
    public function getPedidoShopper($shopperId) {

        $this->conectar();

        $sql2 = "SELECT ceds, noms,
                SUM(((facturado * ( 1 - descuento)) + bazar + facturadodesc) + (saldos*-1) - cobrado) as saldo
                FROM
                (SELECT DISTINCT sh.cedula as ceds, sh.nombres as noms, sh.apellidos as apes, 
                sh.direccion as dirs, sh.telefono as tels, sh.movil as movils,
                net.cedula as cedn, net.nombres as nomn, net.apellidos as apen, 
                ger.cedula as cedg, ger.nombres as nomg, ger.apellidos as apeg,
                ci.nombre as ciclo, ca.numero as campana,
                ifnull(p.valor,0) as cobrado, ifnull(s.pedido,0) as pedido, 
                ifnull(s.facturado,0) - ifnull(aj.diferencia,0) as facturado, 
                ifnull(dev.valor,0) as saldos, ifnull(z.facturado,0) as bazar, 
                ifnull(dfd.facturado,0) as facturadodesc,
                (em.descuento/100) as descuento
                FROM pedido pd
                INNER JOIN paisembarque e ON pd.paisembarque_id = e.id
                INNER JOIN embarque em ON em.id = e.embarque_id 
                INNER JOIN shopper sh ON sh.id = pd.shopper_id 
                INNER JOIN networker net ON net.id = sh.networker_id 
                INNER JOIN ciclo ci ON ci.id = pd.ciclo_id
                INNER JOIN campana ca ON ca.id = ci.campana_id
                LEFT JOIN networker ger ON ger.id = sh.gerentezona_id
                LEFT JOIN digitadofacturado s ON s.paisembarque_id = pd.paisembarque_id AND pd.shopper_id = s.shopper_id
                LEFT JOIN digitadofacturadobazar z ON z.paisembarque_id = pd.paisembarque_id AND pd.shopper_id = z.shopper_id
                LEFT JOIN digitadofacturadodescuento dfd ON dfd.paisembarque_id = pd.paisembarque_id AND pd.shopper_id = dfd.shopper_id
                LEFT JOIN ajusteregla aj ON pd.id = aj.pedido
                LEFT JOIN (SELECT shopper_id, ciclo_id, SUM(valor) as valor FROM pago WHERE tipo = 'ABONO' GROUP BY shopper_id, ciclo_id ) AS p ON p.ciclo_id = pd.ciclo_id AND p.shopper_id = pd.shopper_id
                LEFT JOIN (SELECT shopper_id, ciclo_id, SUM(valor) as valor FROM pago WHERE tipo != 'ABONO' GROUP BY shopper_id, ciclo_id ) AS dev ON dev.ciclo_id = pd.ciclo_id AND dev.shopper_id = pd.shopper_id 
                WHERE sh.id = $shopperId AND ci.id <= 29) mitabla GROUP BY ceds, noms";
        $resultado2 = $this->mysqli->query($sql2) or die ('No se ha podido realizar la operacion : '.$sql2);
        $data2 = $resultado2->fetch_assoc();

        if($shopperId == 8)
					$data2['saldo'] = 0;
				
        if($data2['saldo'] > 1) {
            $fila = array("saldo" => "Estimada Shopper: En nuestro sistema aparece con saldo pendiente. La invitamos a ponerse al dia para que pueda ingresar su pedido.");
        } else {
            $sql = "SELECT e.descuento, p.id as pedidoId, d.id as detalleId, l.descuento_extra, l.mascara, pro.descripcion, l.pagina, pr.valor as precioVenta, d.cantidad "
                . "FROM pedido p "
                . "INNER JOIN paisembarque pe ON pe.id = p.paisembarque_id "
                . "INNER JOIN embarque e ON e.id = pe.embarque_id "
                . "INNER JOIN detallepedido d ON d.pedido_id = p.id "
                . "INNER JOIN leaderlist l ON l.id = d.leaderlist_id "
                . "INNER JOIN producto pro ON pro.id = l.producto_id "
                . "INNER JOIN precio pr ON pr.leaderlist_id = l.id AND pr.pais_id = pe.pais_id "
                . "WHERE e.activo = 1 AND p.shopper_id = $shopperId "
                //. "WHERE e.id = 64 AND p.shopper_id = $shopperId "
                . "ORDER BY d.id DESC";

            $resultado = $this->mysqli->query($sql) or die ('No se ha podido realizar la operacion : '.$sql);
            $cantidad = mysqli_num_rows($resultado);    

            if($cantidad > 0) {
                while($data = $resultado->fetch_assoc())
                        $fila[] = json_encode($data);
            } else {
                    $fila = array("warning" => "No existe pedido para embarque activo");
            }
        }	
        $return['pedido'] = $fila;
        $this->mysqli->close();

        return $return;
    }
	
    public function getPedidoPendientesProcesar() {

        $this->conectar();
        $sql = "SELECT p.id as pedido, pr.sku, SUM(d.cantidad) as cantidad, pr.largo as largo, pr.ancho as ancho, pr.alto as alto, 'PTY' as fuente
        FROM pedido p 
        INNER JOIN paisembarque pe ON pe.id = p.paisembarque_id
        INNER JOIN detallepedido d ON p.id = d.pedido_id 
        INNER JOIN leaderlist l ON l.id = d.leaderlist_id 
        INNER JOIN producto pr ON pr.id = l.producto_id
        INNER JOIN proveedor pro ON pro.id = pr.proveedor_id
        WHERE p.facturado = 0 AND p.procesado = 0 AND pe.embarque_id IN (SELECT id FROM embarque WHERE activo = 1)
        AND l.pagina != 'BAZ' AND pro.nombre = 'MP'
        GROUP BY p.id, pr.sku, pr.largo, pr.ancho, pr.alto";		

        $resultado = $this->mysqli->query($sql) or die ('No se ha podido realizar la operacion : '.$sql);
        $cantidad = mysqli_num_rows($resultado);	

        if($cantidad > 0) {

                while($data = $resultado->fetch_assoc())
                        $fila[] = "[".json_encode($data)."]";

        } else {
                $fila = array("warning" => "No hay pedidos pendientes por procesar del embarque activo");
        }	

        $this->mysqli->close();

        return $fila;
    }
	
    public function actualizarProcesados($listaJson) {

        $this->conectar();
        $decode = json_decode($listaJson, true);

        $cadena = "";
        foreach($decode['pedidos'] as $key => $val)
                $cadena .= $val.",";

        $sql = "UPDATE pedido SET procesado = 1 WHERE id IN (".substr($cadena,0,-1).")";				
        $this->mysqli->query($sql); 
        $this->mysqli->close();
    }
	
    public function actualizarFacturados($listaJson) {

        $decode = json_decode($listaJson, true);
        $this->conectar();

        foreach($decode as $item) {
            $sql = "SELECT DISTINCT id, cantidad FROM detallepedido WHERE pedido_id = ".$item['pedido']." AND 
            leaderlist_id IN (SELECT l.id FROM leaderlist l INNER JOIN producto pr ON pr.id = l.producto_id 
            WHERE pr.sku = '".$item['sku']."');";

            $cantidadFacturado = $item['cantidad'];
            $resultado = $this->mysqli->query($sql) or die ('No se ha podido realizar la operacion : '.$sql);
            while($data = $resultado->fetch_assoc()) {

                if($cantidadFacturado > 0) {

                    if($cantidadFacturado >= $data['cantidad']) {
                            $sqlUpd = "UPDATE detallepedido SET cantidadFacturado = cantidad WHERE id = ".$data['id'].";";						
                            $this->mysqli->query($sqlUpd) or die ('No se ha podido realizar la operacion : '.$sqlUpd);;
                            $cantidadFacturado -= $data['cantidad'];
                    } else {
                            $sqlUpd = "UPDATE detallepedido SET cantidadFacturado = $cantidadFacturado WHERE id = ".$data['id'].";";						
                            $this->mysqli->query($sqlUpd) or die ('No se ha podido realizar la operacion : '.$sqlUpd);;
                            $cantidadFacturado = 0;
                    }
                }
            }
        }			
        $this->mysqli->close();
    }
	
    public function nuevoPedido($shopperId, $usuarioId, $paisId, $cicloId) {

        $this->conectar();
        
        $sql = "SELECT id "
                . "FROM pedido "
                . "WHERE facturado = 0 AND shopper_id = $shopperId "
                . "AND paisembarque_id IN "
                . "(SELECT pe.id FROM paisembarque pe "
                . "INNER JOIN embarque e ON e.id = pe.embarque_id "
                . "WHERE e.activo = 1)";

        $resultado = $this->mysqli->query($sql) or die ('No se ha podido realizar la operacion : '.$sql);
        $cantidad = mysqli_num_rows($resultado);

        if($cantidad == 0) {
            $sql = "INSERT INTO pedido (paisembarque_id, shopper_id, usuario_id, ciclo_id) "
                    . "VALUES ((SELECT pe.id FROM paisembarque pe "
                    . "INNER JOIN embarque e ON e.id = pe.embarque_id "
                    . "WHERE e.activo = 1 AND pe.pais_id = $paisId),$shopperId,$usuarioId,$cicloId)";
            $this->mysqli->query($sql); 

            $id = $this->mysqli->insert_id;
        } else {
            while($data = $resultado->fetch_assoc())
                $id = $data['id'];
        }

        $this->mysqli->close();
        return $id;
    }	
	
    public function agregarItemPedido($mascara, $cant, $pedidoId, $pais, $ciclo) {

        $this->conectar();      
        $sql = "SELECT l.id, l.descuento_extra, l.mascara, pro.descripcion, l.pagina, pre.valor as precioVenta "
                . "FROM leaderlist l "
                . "INNER JOIN producto pro ON pro.id = l.producto_id "
                . "INNER JOIN precio pre ON pre.leaderlist_id = l.id "
                . "WHERE l.mascara = '$mascara' AND pre.pais_id = ".$pais." "
                . "AND l.campana_id = (SELECT campana_id FROM ciclo WHERE id = $ciclo) "
                . "AND l.pagina NOT IN ('PRE','SUS','CAT')";
        $resultado = $this->mysqli->query($sql) or die (file_put_contents('milog.txt', print_r($sql, true)));
        $cantidad = mysqli_num_rows($resultado);

        if($cantidad > 0) {

            $data = $resultado->fetch_assoc();
            $leaderlistId = $data['id'];
            
            //tiene inventario?
            $sql = "select IFNULL(SUM(disponible),0) as inventario
                from inventariosimple 
                where pais_id =
                (select pe.pais_id
                from pedido p
                inner join paisembarque pe on pe.id = p.paisembarque_id
                where p.id = $pedidoId) and
                leaderlist_id = $leaderlistId 
                group by leaderlist_id";
            
            $resultado = $this->mysqli->query($sql) or die (file_put_contents('milog.txt', print_r($sql, true)));
            $inventario = $resultado->fetch_assoc();
            
            if($inventario['inventario'] < 1) {
                $fila = array("warning" => "El producto ingresado no tiene inventario!!!");

                //Busco si tiene sustituto
                $sql_sust = "SELECT leaderlist.id, producto.descripcion, producto.imagen, SUM(inventariosimple.disponible) as cantidad
                FROM sustituto
                INNER JOIN leaderlist ON leaderlist.id = sustituto.sustituto_id
                INNER JOIN producto ON producto.id = leaderlist.producto_id
                INNER JOIN inventariosimple ON inventariosimple.leaderlist_id = leaderlist.id AND inventariosimple.pais_id = 1
                WHERE sustituto.original_id = $leaderlistId AND inventariosimple.disponible > 0 
                GROUP BY leaderlist.id, producto.descripcion, producto.imagen";
                $resultado_sust = $this->mysqli->query($sql_sust) or die (file_put_contents('milog.txt', print_r($sql_sust, true)));
                
                while($data_sust = $resultado_sust->fetch_assoc())
                        $fila['sustitutos'][] = json_encode($data_sust);

            } else if($inventario['inventario'] < $cant) {
                $fila = array("warning" => "El producto ingresado no cuenta con inventario suficiente");

                //Busco si tiene sustituto
                              $sql_sust = "SELECT leaderlist.id, producto.descripcion, producto.imagen, SUM(inventariosimple.disponible) as cantidad
                                    FROM sustituto
                                    INNER JOIN leaderlist ON leaderlist.id = sustituto.sustituto_id
                                    INNER JOIN producto ON producto.id = leaderlist.producto_id
                                    INNER JOIN inventariosimple ON inventariosimple.leaderlist_id = leaderlist.id AND inventariosimple.pais_id = 1
                                    WHERE sustituto.original_id = $leaderlistId AND inventariosimple.disponible > 0 
                                    GROUP BY leaderlist.id, producto.descripcion, producto.imagen";
                                    $resultado_sust = $this->mysqli->query($sql_sust) or die (file_put_contents('milog.txt', print_r($sql_sust, true)));
                                while($data_sust = $resultado_sust->fetch_assoc())
                        $fila[] = json_encode($data_sust);
            } else {
                
                $sql = "SELECT id FROM detallepedido WHERE leaderlist_id = $leaderlistId AND pedido_id = $pedidoId";
                $resultado = $this->mysqli->query($sql) or die ('No se ha podido realizar la operacion : '.$sql);
                $cantidadDetalle = mysqli_num_rows($resultado);

                if($cantidadDetalle > 0) {
                    $sql = "UPDATE detallepedido SET cantidad = cantidad + $cant WHERE
                                    pedido_id = $pedidoId AND leaderlist_id = $leaderlistId";               
                    $this->mysqli->query($sql) or die (file_put_contents('milog.txt', print_r($sql, true)));

                } else {
                    $sql = "INSERT INTO detallepedido (pedido_id, leaderlist_id, cantidad) 
                                    VALUES ($pedidoId, $leaderlistId, $cant)";              
                    $this->mysqli->query($sql) or die (file_put_contents('milog.txt', print_r($sql, true)));
                }
                
                //Reserva de inventario
                $sql = "select id, disponible
                        from inventariosimple 
                        where pais_id =
                        (select pe.pais_id
                        from pedido p
                        inner join paisembarque pe on pe.id = p.paisembarque_id
                        where p.id = $pedidoId) and
                        leaderlist_id = $leaderlistId";
                $resultado = $this->mysqli->query($sql) or die (file_put_contents('milog.txt', print_r($sql, true)));                
                while($res = $resultado->fetch_assoc()) {
                    if($res['disponible'] < 1 || $cant < 1)
                                continue;
                                
                    if($res['disponible'] >= $cant)
                    {
                        $sqlRes = "UPDATE inventario SET reservado = reservado + $cant WHERE id = ".$res['id'];
                        $this->mysqli->query($sqlRes) or die (file_put_contents('milog.txt', print_r($sqlRes, true)));
                        break;
                    } else {
                        $sqlRes = "UPDATE inventario SET reservado = reservado + " . $res['disponible'] . " WHERE id = ".$res['id'];
                        $this->mysqli->query($sqlRes) or die (file_put_contents('milog.txt', print_r($sqlRes, true)));
                        $cant -= $res['disponible'];
                    }
                }
            
                //Vuelvo a obtener todo el pedido
                $sql = "SELECT e.descuento, p.id as pedidoId, d.id as detalleId, l.descuento_extra, l.mascara, pro.descripcion, l.pagina, pr.valor as precioVenta, d.cantidad "
                        . "FROM pedido p "
                        . "INNER JOIN paisembarque pe ON pe.id = p.paisembarque_id "
                        . "INNER JOIN embarque e ON e.id = pe.embarque_id "
                        . "INNER JOIN detallepedido d ON d.pedido_id = p.id "
                        . "INNER JOIN leaderlist l ON l.id = d.leaderlist_id "
                        . "INNER JOIN producto pro ON pro.id = l.producto_id "
                        . "INNER JOIN precio pr ON pr.leaderlist_id = l.id AND pr.pais_id = pe.pais_id "
                        . "WHERE p.id = $pedidoId "
                        . "ORDER BY d.id DESC";     
                
                $resultado = $this->mysqli->query($sql) or die (file_put_contents('milog.txt', print_r($sql, true)));   
                while($data = $resultado->fetch_assoc())
                        $fila[] = json_encode($data);
            }

        } else  
            $fila = array("warning" => "El producto ingresado no corresponde a un producto de la campaña en curso.");

        $this->mysqli->close();
        $return['pedido'] = $fila;

        return $return;
    }

    public function agregarSustitutoPedido($mascara, $cant, $pedidoId, $pais, $ciclo) {

        $this->conectar();      
        $sql = "SELECT l.id, l.descuento_extra, l.mascara, pro.descripcion, l.pagina, pre.valor as precioVenta "
                . "FROM leaderlist l "
                . "INNER JOIN producto pro ON pro.id = l.producto_id "
                . "INNER JOIN precio pre ON pre.leaderlist_id = l.id "
                . "WHERE l.id = '$mascara' AND pre.pais_id = ".$pais;
        $resultado = $this->mysqli->query($sql) or die (file_put_contents('milog.txt', print_r($sql, true)));
        $cantidad = mysqli_num_rows($resultado);

        if($cantidad > 0) {

            $data = $resultado->fetch_assoc();
            $leaderlistId = $data['id'];
                
            $sql = "SELECT id FROM detallepedido WHERE leaderlist_id = $leaderlistId AND pedido_id = $pedidoId";
            $resultado = $this->mysqli->query($sql) or die ('No se ha podido realizar la operacion : '.$sql);
            $cantidadDetalle = mysqli_num_rows($resultado);

            if($cantidadDetalle > 0) {
                $sql = "UPDATE detallepedido SET cantidad = cantidad + $cant WHERE
                                pedido_id = $pedidoId AND leaderlist_id = $leaderlistId";				
                $this->mysqli->query($sql) or die (file_put_contents('milog.txt', print_r($sql, true)));

            } else {
                $sql = "INSERT INTO detallepedido (pedido_id, leaderlist_id, cantidad) 
                                VALUES ($pedidoId, $leaderlistId, $cant)";				
                $this->mysqli->query($sql) or die (file_put_contents('milog.txt', print_r($sql, true)));
            }
            
            //Reserva de inventario
            $sql = "select id, disponible
                    from inventariosimple 
                    where pais_id =
                    (select pe.pais_id
                    from pedido p
                    inner join paisembarque pe on pe.id = p.paisembarque_id
                    where p.id = $pedidoId) and
                    leaderlist_id = $leaderlistId";
            $resultado = $this->mysqli->query($sql) or die (file_put_contents('milog.txt', print_r($sql, true)));                
            while($res = $resultado->fetch_assoc()) {
                if($res['disponible'] < 1 || $cant < 1)
                            continue;
                            
                if($res['disponible'] >= $cant)
                {
                    $sqlRes = "UPDATE inventario SET reservado = reservado + $cant WHERE id = ".$res['id'];
                    $this->mysqli->query($sqlRes) or die (file_put_contents('milog.txt', print_r($sqlRes, true)));
                    break;
                } else {
                    $sqlRes = "UPDATE inventario SET reservado = reservado + " . $res['disponible'] . " WHERE id = ".$res['id'];
                    $this->mysqli->query($sqlRes) or die (file_put_contents('milog.txt', print_r($sqlRes, true)));
                    $cant -= $res['disponible'];
                }
            }
        
            //Vuelvo a obtener todo el pedido
            $sql = "SELECT e.descuento, p.id as pedidoId, d.id as detalleId, l.descuento_extra, l.mascara, pro.descripcion, l.pagina, pr.valor as precioVenta, d.cantidad "
                    . "FROM pedido p "
                    . "INNER JOIN paisembarque pe ON pe.id = p.paisembarque_id "
                    . "INNER JOIN embarque e ON e.id = pe.embarque_id "
                    . "INNER JOIN detallepedido d ON d.pedido_id = p.id "
                    . "INNER JOIN leaderlist l ON l.id = d.leaderlist_id "
                    . "INNER JOIN producto pro ON pro.id = l.producto_id "
                    . "INNER JOIN precio pr ON pr.leaderlist_id = l.id AND pr.pais_id = pe.pais_id "
                    . "WHERE p.id = $pedidoId "
                    . "ORDER BY d.id DESC";		
            
            $resultado = $this->mysqli->query($sql) or die (file_put_contents('milog.txt', print_r($sql, true)));	
            while($data = $resultado->fetch_assoc())
                    $fila[] = json_encode($data);

        } else	
            $fila = array("warning" => "El producto ingresado no corresponde a un producto de la campaña en curso.");

        $this->mysqli->close();
        $return['pedido'] = $fila;

        return $return;
    }
	
    public function eliminarItemPedido($detalleId) {

        $this->conectar();
        $sql = "SELECT * FROM detallepedido WHERE id = $detalleId";
        $resultado = $this->mysqli->query($sql) or die ('No se ha podido realizar la operacion : '.$sql);
        $detalle = $resultado->fetch_assoc();
        $cantidadBorrar = $detalle['cantidad'];
        $pedidoId = $detalle['pedido_id'];
        $leaderlistId = $detalle['leaderlist_id'];
        
        $sql = "DELETE FROM detallepedido WHERE id = $detalleId";				
        $this->mysqli->query($sql) or die ('No se ha podido realizar la operacion : '.$sql);
        $cantidad = $this->mysqli->affected_rows;	

        //Restar unidades reservadas
        $sql = "select id, disponible
                from inventariosimple 
                where pais_id =
                (select pe.pais_id
                from pedido p
                inner join paisembarque pe on pe.id = p.paisembarque_id
                where p.id = $pedidoId) and
                leaderlist_id = $leaderlistId";
        $resultado = $this->mysqli->query($sql) or die (file_put_contents('milog.txt', print_r($sql, true)));
        while($res = $resultado->fetch_assoc()) {          
            if($cantidadBorrar < 1)
                break;

            $sql2 = "select id, reservado from inventario where reservado > 0 and id = ".$res['id'];
            $resultado2 = $this->mysqli->query($sql2) or die (file_put_contents('milog.txt', print_r($sql2, true)));
            $numro = mysqli_num_rows($resultado2);
            
            if($numro > 0) {
                $res2 = $resultado2->fetch_assoc();
                
                if($res2['reservado'] >= $cantidadBorrar) {
                    $sqlRes = "UPDATE inventario SET reservado = reservado - $cantidadBorrar WHERE id = ".$res2['id'];
                    $this->mysqli->query($sqlRes) or die (file_put_contents('milog.txt', print_r($sqlRes, true)));
                    break;
                } else {
                    $sqlRes = "UPDATE inventario SET reservado = reservado - ".$res2['reservado']." WHERE id = ".$res2['id'];
                    $this->mysqli->query($sqlRes) or die (file_put_contents('milog.txt', print_r($sqlRes, true)));
                    $cantidadBorrar -= $res2['reservado'];
                }    
            }
        }
                
        if($cantidad > 0)
            $fila = array("success" => "Se ha eliminado el producto correctamente");
        else	
            $fila = array("warning" => "No existe el producto a eliminar");

        $this->mysqli->close();

        return $fila;
    }
}

?>